{                        }
{  EXE 䠩  COM}
{                        }
{ Param : EXEFILE.EXE    }
{ Out   : EXEFILE.COM    }

{$M 1024,65535,100000}

USES CRT,DOS;

CONST
   Par	=	1;

TYPE
  TEXEHeader = RECORD
		Signature : WORD;
		PartPag   : WORD;
		FileSize  : WORD;
		RelCnt    : WORD;
                HdrSize   : WORD;
                MinAlloc  : WORD;
                MaxAlloc  : WORD;
                SS0       : WORD;
                SP0       : WORD;
                CheckSum  : WORD;
                IP0       : WORD;
                CS0       : WORD;
                RelOfs    : WORD;
                Ovl       : WORD;
               END;

VAR
 Hdr : TEXEHeader;
 F : File;
 T : ^Pointer;
 D : DirStr;
 N : NameStr;
 E : ExtStr;
 NN : String;

Procedure Er(s : String);
Begin
 WriteLn(s);
 Halt;
End;

BEGIN
 GetMem(T,$FFF0);
 If T = Nil Then Er('Mem');
 If ParamCount < 1 Then Er('Param?');
 Assign(F,ParamStr(1));
 Reset(F,1);
 BlockRead(F,Hdr,SizeOf(TEXEHeader));
 If Hdr.RelCnt <> 0 Then Er('Cannot convert!');
 Seek(F,Hdr.HdrSize * 16);
 BlockRead(F,T^,(Hdr.FileSize - 1) * 512 + Hdr.PartPag - Hdr.HdrSize * 16);
 Close(F);
 FSplit (ParamStr(1),D,N,E);
 Assign(F,D + N + '.COM');
 ReWrite(F,1);
 BlockWrite(F,T^,(Hdr.FileSize - 1) * 512 + Hdr.PartPag - Hdr.HdrSize * 16);
 Close(F);
END.

